// =================================================================
//
// CBPFBO_StepperA.h
// 20-08-21
// Revs. 22-08-21
//
// =================================================================

#ifndef CBPFBO_STEPPER_H
#define CBPFBO_STEPPER_H

#include <Arduino.h>
#include <Stepper.h>
#include <Pixy2.h>

#define dx 0.07225
#define rob_dia 94

#define TEE 1
#define LEFT 2
#define RIGHT 4
#define NONE 0

void stepMotors( int stepLeft, int stepRight);

int ramp(int vMin, int vMax, int N, float alpha, int n, bool upRamp, bool downRamp);

void straightLine(int dist, int vMax, bool upRamp, bool downRamp); 

int detectCorner(int16_t angs[]);

int detectCornersOrig(int16_t angs[]);

int detectCorners(int16_t angs[]);

// Function for path tracking. Moves forward, detects junction, breaks
// out of movement while(...) then advances half a track width, then
// samples juntion type to return. Then advances until wheels on then
// junction, then returns. 

// Copied from Parallax version (working). This code is under development
	
int moveForward(Pixy2 pixy, int vMax, int dist);
 
// pivot function handles positive and negative angles (degrees)
void pivot(float degs);
 
void arc(float R, float a, float theta, int vMax, bool upRamp, bool downRamp);
 
// Get error = leftVal - rightVal. Normalize by maxDiff
float getError();

// Move depending on error
void moveABit(	float error, float deltaT);

// IRed Reflectance Sensing
long RCTime(int sensorIn);

#endif
